var Base = require('../base')
  , Publisher = require('./publisher')
  , Connector = require('./connector')
  , Crypto = require('./crypto')


exports.start = function(cb_err_data){
  Base.env(function(){
    Publisher.publishAndFindProxy(function(err, data){
      if (err && !cb_err_data) { throw err }
      if (err) { cb_err_data(err, data); return }

      Connector.connectToProxy(data, function(err, data){
        if (err && !cb_err_data) { throw err }
        if (cb_err_data) { cb_err_data(err, data) }
      })
    })
  })
}

exports.setKey = function(key){
  Crypto.setKey(key)
}
